-------------------------------------------------------------------------------
--
-- Decodificador de Leitura
--
-- Este bloco combinacional gera sinais de habilitao de dispositivos
-- tristate interpostos entre os registradores e barramentos.
--
--   FERNANDO GEHM MORAES         03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
-------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use work.PacoteCleopatra.all;

entity DecodificadorLeitura is
	port
	(
		read_reg: in std_logic_vector(3 downto 0);
		r_mdr: out std_logic;
		r_ir: out std_logic;
		r_pc: out std_logic;
		r_ac: out std_logic;
		r_rs: out std_logic;
		r_idx: out std_logic
	);
end DecodificadorLeitura;

architecture DecodificadorLeitura of DecodificadorLeitura is
begin

	--- Cdigos de leitura nos registradores (codificao de leitura):
	--- 1 MDR, 2 IR, 3 PC, 4 AC, 5 RS, 6 MDR/AC, 7 MDR/PC, 8 IDX/MDR, DEMAIS no l nenhum registrador

	r_idx <= '1' when read_reg = "1000" else '0';
	r_mdr <= '1' when read_reg = "0001" or read_reg = "0110" or read_reg = "0111" or read_reg = "1000" else '0';
	r_ir <= '1' when read_reg = "0010" else '0';
	r_pc <= '1' when read_reg = "0011" or read_reg = "0111" else '0';
	r_ac <= '1' when read_reg = "0100" or read_reg = "0110" else '0';
	r_rs <= '1' when read_reg = "0101" else '0';

end DecodificadorLeitura;
